(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('axios'), require('js-base64')) :
    typeof define === 'function' && define.amd ? define(['exports', 'axios', 'js-base64'], factory) :
    (factory((global.hbBasicJsSdk = {}),global.axios,global.jsBase64));
}(this, (function (exports,axios,jsBase64) { 'use strict';

    axios = axios && axios.hasOwnProperty('default') ? axios['default'] : axios;

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __awaiter(thisArg, _arguments, P, generator) {
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    var DeptTag = {
        // 职能划分
        Function: {
            CLINICAL: { id: 'A01', name: '临床' },
            MEDICAL_TECHNOLOGY: { id: 'A02', name: '医技' },
            TREATMENT: { id: 'A03', name: '治疗' },
            FINANCE: { id: 'A04', name: '财务' },
            LOGISTICS: { id: 'A05', name: '后勤' },
            ADMINISTRATION: { id: 'A06', name: '行政' },
            MANAGE: { id: 'A07', name: '管理' },
            MEDICAL_AUXILIARY: { id: 'A08', name: '医辅' }
        },
        // 急诊划分
        OpFlag: {
            OP: { id: 'B01', name: '门诊' },
            IP: { id: 'B02', name: '住院' },
            ER: { id: 'B03', name: '急诊' },
            PE: { id: 'B04', name: '体检' }
        },
        // 急诊划分
        MedicalSystem: {
            WM: { id: 'C01', name: '西医' },
            TCM: { id: 'C02', name: '中医' }
        },
        // 治疗划分
        Treat: {
            OR: { id: 'D01', name: '手术室' },
            NARCOTISM: { id: 'D02', name: '麻醉科' },
            DSA: { id: 'D03', name: 'DSA' },
            ICU: { id: 'D04', name: 'ICU' },
            HEMODIALYSIS: { id: 'D05', name: '血透' },
            CHEMOTHERAPY: { id: 'D06', name: '化疗' },
            RADIOTHERAPY: { id: 'D07', name: '放疗' },
            HPO: { id: 'D08', name: '高压氧' },
            TCM: { id: 'D09', name: '中医治疗' },
            REHABILITATION: { id: 'D10', name: '康复治疗' }
        },
        // 药房划分
        Storeroom: {
            DRUG_ROOM: { id: 'E01', name: '药房' },
            DRUG_LIBRARY: { id: 'E02', name: '药库' },
            MATERIAL_ROOM: { id: 'E03', name: '材料房' },
            MATERIAL_LIBRARY: { id: 'E04', name: '材料库' }
        },
        // 其他划分
        Other: {
            CHARGE: { id: 'F01', name: '收费处' },
            METACHYSIS: { id: 'F02', name: '输血科' },
            RECORD_ROOM: { id: 'F03', name: '病案室' },
            MEDICAL: { id: 'F04', name: '医务科' },
            QUALITY_CONTROL: { id: 'F05', name: '质控科' }
        }
    };

    /*
     * @Author: 储金柱
     * @Date: 2022-01-24 20:11:16
     * @LastEditors: ld10016 763725112@qq.com
     * @LastEditTime: 2022-05-17 13:52:04
     * @Description:
     * @FilePath: \src\sdk\lib\utils.ts
     */

    /*
     * @Author: 刘邓
     * @Date: 2022-08-11 09:40:14
     * @LastEditors: 文贝
     * @LastEditTime: 2022-09-28 13:30:11
     * @Description:
     * @FilePath: \hb-basic-js-sdk\src\api\imedx-base.ts
     */
    // const baseUrl = ''
    var imedxBase = {
        // 获取字典数据
        getDictList: '/dict/dict/get',
        getInpatientAge: '/sys/getInpatientAge',
        getOutpatientAge: '/sys/getOutpatientAge'
    };

    var baseUrl = '/hbbasic';
    var base = {
        // 登录
        login: baseUrl + '/user/login',
        // 判断科室是否存在对应的职能
        checkDept: baseUrl + '/org/check/dept/fun',
        // 根据 token 获取用户信息
        getUserInfoByToken: baseUrl + '/user/information',
        // 获取用户所在科室与病区
        getUserDeptList: baseUrl + '/user/dept/list',
        //修改用户密码
        setPassWord: baseUrl + '/user/password/update',
        //获取用户权限科室
        getAuthDeptList: baseUrl + '/user/auth/dept/list',
        //获取用户特殊权限列表
        getUserSpecRightList: baseUrl + '/user/special/right/list',
        //CA 登录接口
        caLogin: baseUrl + '/user/login/ca',
        //获取应用列表
        getApplist: baseUrl + '/app/list',
        //特殊权限注册
        registerSpecRight: baseUrl + '/special/right/register',
        //注册应用菜单
        registerAppMenu: baseUrl + '/app/menu/register',
        //注册应用菜单功能按钮
        registerAppMenuOper: baseUrl + '/app/menu/oper/register',
        //获取指定用户应用菜单列表
        getAppMenuList: baseUrl + '/app/menu/list',
        //获取指定用户菜单下的按钮列表
        getAppMenuOperList: baseUrl + '/app/menu/oper/list',
        // 获取用户权限应用列表
        getAppUserRightList: baseUrl + '/app/user/right/list',
        //记录用户最近访问菜单
        setVisitRecord: baseUrl + '/app/module/visit/record/save',
        //获取用户最近访问菜单列表
        getVisitRecordList: baseUrl + '/app/recent/module/list',
        //获取用户常用菜单列表
        getCommonMenuList: baseUrl + '/common/menu/list',
        //用户常用功能菜单注册
        registerCommonMenu: baseUrl + '/common/menu/register',
        //取消用户常用菜单注册
        registerCommonMenuCancel: baseUrl + '/common/menu/cancel/register',
        //用户常用菜单排序
        sortCommonMenu: baseUrl + '/common/menu/sort',
        //获取机构列表
        getOrgList: baseUrl + '/org/list',
        //根据科室或病区获取机构信息
        getInfoByDept: baseUrl + '/org/information/by/dept',
        //检查两个科室或病区是否属于同一分院
        checkOrgSame: baseUrl + '/org/check/same',
        //判断用户是否是某个病区领导（护士长）
        checkNurseUnitLeader: baseUrl + '/user/check/nursing/unit/leader',
        //判断用户是否是某个科室领导（科主任）
        checkDeptLeader: baseUrl + '/user/check/dept/leader',
        // 根据指定流水号编码获取流水号
        getSerialNum: baseUrl + '/serial/number/book/get',
        //注册流水号
        registerSerialNum: baseUrl + '/serial/number/book/register',
        //获取字典数据分页列表
        getDictDataPage: baseUrl + '/dict/data/page',
        //根据菜单类别获取菜单列表
        getAppMenuCateList: baseUrl + '/app/menu/category/list',
        //获取应用字典数据分页列表
        getAppDictDataPage: baseUrl + '/app/dict/data/page',
        //获取应用参数值列表
        getAppParamList: baseUrl + '/app/param/list',
        //根据应用菜单编码获取已注册系统参数列表
        getSystemParamList: baseUrl + '/system/param/list',
        //获取系统参数值
        getSystemParamValue: baseUrl + '/system/param/value',
        //设置系统参数
        setSystemParam: baseUrl + '/system/param/settings',
        //根据应用菜单编码获取已注册本地参数列表
        getLocalParamList: baseUrl + '/local/param/list',
        //获取本地参数值
        getLocalParamValue: baseUrl + '/local/param/value',
        //本地参数设置
        setLocalParam: baseUrl + '/local/param/settings',
        //本地参数值设置
        setLocalParamValue: baseUrl + '/local/param/value/settings',
        //获取系统参数值列表
        getSystemParamValueList: baseUrl + '/system/param/value/list',
        //客户端验证
        checkClient: baseUrl + '/client/check',
        //客户端注册
        registerClient: baseUrl + '/client/register',
        //根据客户端编码获取客户端信息
        getClientInfo: baseUrl + '/client/info',
        //获取数据验证规则列表
        getDataValidRuleList: baseUrl + '/data/validation/rule/list',
        // 获取全局唯一ID
        getUniqueKey: baseUrl + '/common/key/get',
        // 包上传注册
        packageRegister: baseUrl + '/package/register',
        // 获取机构下全部病区科室
        getDeptListByOrg: baseUrl + '/org/dept/list',
        // 获取机构下全部建筑与楼层
        getOrgBuildingList: baseUrl + '/org/building/list',
        // 获取机构或科室下的全部医生或护士
        getOrgUserList: baseUrl + '/org/user/list',
        // 获取机构Logo
        getOrgLogo: baseUrl + '/org/get/logo',
        //  更据工号获取用户信息
        getUserByCode: baseUrl + '/user/code',
        //  获取全部用户信息
        getUserList: baseUrl + '/user/list',
        //  获取用户权限科室-病区
        getUserDeptWardList: baseUrl + '/user/dept/ward/list',
        //  验证用户密码
        userVerifyPassword: baseUrl + '/user/verify/password',
        //  获取注册的医生、护士
        getUserRegisterList: baseUrl + '/user/register/list',
        //  获取用户签名图片
        getUserSign: baseUrl + '/user/get/sign',
        //  获取用户权限机构列表
        getUserAuthOrgList: baseUrl + '/user/auth/org/list',
        //  获取急诊科室
        getErDeptList: baseUrl + '/org/er/dept/list',
        //  获取医生病区
        getDoctorWard: baseUrl + '/user/doctor/ward',
        //  获取科室主任
        getDeptDirector: baseUrl + '/user/dept/director',
        //  获取诊区
        listConsultingArea: baseUrl + '/appt-std-register-type/list',
        //  获取诊室
        listConsultingRoom: baseUrl + '/appt-consulting-room/list',
        //  获取科室科目配置信息
        listDeptSubject: baseUrl + '/appt-dept-subject/list',
        //  获取班次配置
        listDuration: baseUrl + '/appt-duration/list',
        //  获取标准号类信息
        listStdRegisterType: baseUrl + '/appt-std-register-type/list',
        // 授权验证
        authorization: baseUrl + '/verify/api',
        // 退出登录
        logout: baseUrl + '/user/logout',
        // 获取科室病区-进销存专用
        deptListStore: baseUrl + '/org/dept/list/store',
        // 更据AccessKey获取token
        tokenByAccessKey: baseUrl + '/user/token'
    };

    var api = __assign(__assign({}, base), imedxBase);

    var usuallyUrlList = Object.values(imedxBase);
    (function (ContentType) {
        ContentType["form"] = "application/x-www-form-urlencoded";
        ContentType["json"] = "application/json; charset=utf-8";
        ContentType["multipart"] = "multipart/form-data";
    })(exports.ContentType || (exports.ContentType = {}));
    // 普通的，不需要加密的
    function usuallyHttps(config) {
        var appId = config.appId;
        var https = axios.create(config);
        https.interceptors.request.use(function (config) {
            var headers = config.headers;
            config.headers = __assign(__assign({}, headers), { 'content-type': exports.ContentType.json });
            config.method = 'POST';
            // contentType为form时，参数属性名为params
            var params = config.params ? config.params : config.data;
            params = __assign(__assign({}, params), { appId: appId });
            if (config.params) {
                config.params = params;
            }
            else {
                config.data = params;
            }
            return config;
        });
        https.interceptors.response.use(function (response) {
            var data = response.data;
            data.config = response.config;
            return data;
        }, function (error) {
            return Promise.reject(error);
        });
        return https;
    }
    var HBBasicClient = /** @class */ (function () {
        function HBBasicClient(config) {
            this.deptTag = DeptTag;
            this.api = this.getApis(api);
            // this.httpClient = https(config)
            this.httpClient = usuallyHttps(config);
        }
        HBBasicClient.prototype.$post = function (url, data, hasCatchError) {
            if (hasCatchError === void 0) { hasCatchError = false; }
            return __awaiter(this, void 0, void 0, function () {
                var resData;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            resData = null;
                            return [4 /*yield*/, this.httpClient.request({ url: url, data: data, hasCatchError: hasCatchError })];
                        case 1:
                            resData = _a.sent();
                            return [2 /*return*/, Promise.resolve(resData)];
                    }
                });
            });
        };
        HBBasicClient.prototype.getApis = function (api$$1) {
            var _this = this;
            var apiObj = {};
            var _loop_1 = function (key) {
                apiObj[key] = function (data, hasCatchError) {
                    if (hasCatchError === void 0) { hasCatchError = false; }
                    return _this.$post(api$$1[key], data, hasCatchError);
                };
            };
            for (var key in api$$1) {
                _loop_1(key);
            }
            return apiObj;
        };
        return HBBasicClient;
    }());

    exports.default = HBBasicClient;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=hb-basic-js-sdk.umd.js.map
